//+------------------------------------------------------------------+
//|                                           AlphaManagement EA.mq4 |
//|                              Copyright  2010, MethodTraders.com |
//|                                     http://www.MethodTraders.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MethodTraders.com"
#property link      "http://www.MethodTraders.com"


extern string
   EA_Settings             = "-------- General Settings";
extern int
   MagicNumber             = 12345,
   TakeProfit              = 50,
   StopLoss                = 50,
   TrailingStop            = 15,
   NextEntryAddPip         = 2;
extern double
   Lots                    = 1.0; 
extern bool
   TradeLong               = true,
   TradeShort              = false;


bool InitialTrade = true;
int Slippage = 0;  
bool UseTrailStop          = true;
int TrailStop_Trigger      = 0;  
datetime TT;   
int MyDigits;
double MyPoint;   
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
   
   if(Digits==5)MyDigits=4;
   else if(Digits==3)MyDigits=2;
   else MyDigits = Digits; 
   if (Point == 0.00001) MyPoint = 0.0001; //6 digits
   else if (Point == 0.001) MyPoint = 0.01; //3 digits (for Yen based pairs)
   else MyPoint = Point; //Normal
  
   TT = iTime(Symbol(),0,0);
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

   
   
   
   if(UseTrailStop)subTrailingStop(TrailStop_Trigger, TrailingStop);

   int ticket = 0;
   
   if(InitialTrade == true && TradeLong==true && subTotalTrade()<1 && TT!=iTime(Symbol(),0,0))
   {
      ticket = subOpenOrder(OP_BUY, StopLoss, TakeProfit, Lots);
      if(ticket>0)
      {
         TT=iTime(Symbol(),0,0);
         InitialTrade = false;
      }
   }
   
   if(InitialTrade == true && TradeShort==true && subTotalTrade()<1 && TT!=iTime(Symbol(),0,0))
   {
      ticket = subOpenOrder(OP_SELL, StopLoss, TakeProfit, Lots);
      if(ticket>0)
      {
         TT=iTime(Symbol(),0,0);
         InitialTrade = false;
      }
   }
   
   
   
   double NextLongTrade = subLastClose()+(TrailingStop*MyPoint);
   double NextShortTrade = subLastClose()-(TrailingStop*MyPoint);
   
   string Signal = "none";
   if(TradeLong==true && Ask>NextLongTrade+(NextEntryAddPip*MyPoint) && subTotalTrade()<1)Signal = "BUY";
   if(TradeShort==true && Bid<NextShortTrade-(NextEntryAddPip*MyPoint) && subTotalTrade()<1)Signal = "SELL";
   
   
   //OPEN TRADES
   if(subTotalTrade()<1 && (NextLongTrade>1 || NextShortTrade>1)) //&& TT!=iTime(Symbol(),0,0)
   {
      //BUY
      if(Signal == "BUY")
      {
         ticket = subOpenOrder(OP_BUY, StopLoss, TakeProfit, Lots);
         //if(ticket>0)TT=iTime(Symbol(),0,0);
      }
      //SELL
      if(Signal == "SELL")
      {
         ticket = subOpenOrder(OP_SELL, StopLoss, TakeProfit, Lots);
         //if(ticket>0)TT=iTime(Symbol(),0,0);
      }
      
   }  
   
   /*
   Comment("NextLongTrade: "+DoubleToStr(NextLongTrade,Digits)+"\n"+
           "NextShortTrade: "+DoubleToStr(NextShortTrade,Digits)+"\n"+
           "Signal: "+Signal+"\n"+
           "subLastClose: "+DoubleToStr(subLastClose(),Digits)+"");
   
   */
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

// COUNTS THE TOTAL TRADE
int subTotalTrade()
{
   int
      cnt, 
      total = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber) total++;
   }
   return(total);
}

// OPENS ORDERS WITH ECN
int subOpenOrder(int type, int stoploss, int takeprofit, double Lotz) 
{
   
   string TicketComment = "Alpha Management EA";
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;

   
   int NumberOfTries = 10;
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         RefreshRates();
         if(stoploss!=0)
         {
            aStopLoss   = NormalizeDouble(Ask-stoploss*MyPoint,MyDigits);
            bStopLoss   = NormalizeDouble(Bid+stoploss*MyPoint,MyDigits);
         }
   
         if(takeprofit!=0)
         {
            aTakeProfit = NormalizeDouble(Ask+takeprofit*MyPoint,MyDigits);
            bTakeProfit = NormalizeDouble(Bid-takeprofit*MyPoint,MyDigits);
         }
         ticket=OrderSend(Symbol(),OP_BUY,Lotz,Ask,Slippage,0,0,TicketComment,MagicNumber,0,Green);
         if(ticket>0)OrderModify(ticket, OrderOpenPrice(), aStopLoss, aTakeProfit, 0, CLR_NONE); 
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            Print("ERROR: "+err);
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         RefreshRates();
         if(stoploss!=0)
         {
            aStopLoss   = NormalizeDouble(Ask-stoploss*MyPoint,MyDigits);
            bStopLoss   = NormalizeDouble(Bid+stoploss*MyPoint,MyDigits);
         }
   
         if(takeprofit!=0)
         {
            aTakeProfit = NormalizeDouble(Ask+takeprofit*MyPoint,MyDigits);
            bTakeProfit = NormalizeDouble(Bid-takeprofit*MyPoint,MyDigits);
         }
         ticket=OrderSend(Symbol(),OP_SELL,Lotz,Bid,Slippage,0,0,TicketComment,MagicNumber,0,Red);
         if(ticket>0)OrderModify(ticket, OrderOpenPrice(), bStopLoss, bTakeProfit, 0, CLR_NONE); 
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            Print("ERROR: "+err);
            Print(NormalizeDouble(Bid-takeprofit*MyPoint,MyDigits));
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }  
   return(ticket);
}

//----------------------- TRAILING STOP SECTION
void subTrailingStop(int TS_MinProfit, int TrailingStop)
{
    int total = OrdersTotal();
    for(int cnt=0;cnt<total;cnt++)
    {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

        if(OrderType()<=OP_SELL &&
             OrderSymbol()==Symbol() &&
             OrderMagicNumber()==MagicNumber)
        {
           if(OrderType()==OP_BUY)   // buy position is opened   
           {
               if(Bid-OrderOpenPrice()>MyPoint*TS_MinProfit &&
               OrderStopLoss()<Bid-(MyPoint*TrailingStop))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(MyPoint*TrailingStop),OrderTakeProfit(),0,Green);
               }
          
           }         
           if(OrderType()==OP_SELL)   // sell position is opened   
           {
                  
               if(OrderOpenPrice()-Ask>MyPoint*TS_MinProfit)
               {
                  if(OrderStopLoss()>Ask+(MyPoint*TrailingStop) || OrderStopLoss()==0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(MyPoint*TrailingStop),OrderTakeProfit(),0,Red);
                     //return(0);
                  }
                }    
           }
        }
     }
}           

// FINDS THE LAST ORDER TYPE
double subLastClose()
{
    int orders = OrdersHistoryTotal();
    double LC = 0; 
    for(int i=orders-1;i>=0;i--)
    {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MagicNumber) continue;
         //----
            LC = OrderClosePrice();
            break;
    }

    return(LC);
}

